"use strict";var f=Object.defineProperty;var w=Object.getOwnPropertyDescriptor;var A=Object.getOwnPropertyNames,S=Object.getOwnPropertySymbols;var O=Object.prototype.hasOwnProperty,F=Object.prototype.propertyIsEnumerable;var x=(t,n,i)=>n in t?f(t,n,{enumerable:!0,configurable:!0,writable:!0,value:i}):t[n]=i,C=(t,n)=>{for(var i in n||(n={}))O.call(n,i)&&x(t,i,n[i]);if(S)for(var i of S(n))F.call(n,i)&&x(t,i,n[i]);return t};var D=(t,n)=>{for(var i in n)f(t,i,{get:n[i],enumerable:!0})},N=(t,n,i,d)=>{if(n&&typeof n=="object"||typeof n=="function")for(let l of A(n))!O.call(t,l)&&l!==i&&f(t,l,{get:()=>n[l],enumerable:!(d=w(n,l))||d.enumerable});return t};var $=t=>N(f({},"__esModule",{value:!0}),t),e=(t,n,i,d)=>{for(var l=d>1?void 0:d?w(n,i):n,h=t.length-1,m;h>=0;h--)(m=t[h])&&(l=(d?m(n,i,l):m(l))||l);return d&&l&&f(n,i,l),l};var V={};D(V,{CrossmintEvents:()=>v.CrossmintEvents,CrossmintPayButton:()=>o,CrossmintPaymentElement:()=>c,useCrossmintEvents:()=>v.useCrossmintEvents});module.exports=$(V);var y=require("lit"),a=require("lit/decorators.js"),T=require("lit/decorators/custom-element.js"),g=require("@crossmint/client-sdk-base");var p={collectionId:"",projectId:"",mintConfig:{},recipient:{email:"",wallet:""},paymentMethod:"fiat",currency:"usd",locale:"en-US",uiConfig:{},environment:"production",whPassThroughArgs:void 0,onEvent:void 0,experimental:void 0},c=class extends y.LitElement{constructor(){super(...arguments);this.clientId="";this.collectionId="";this.projectId=p.projectId;this.mintConfig=p.mintConfig;this.recipient=p.recipient;this.paymentMethod=p.paymentMethod;this.currency=p.currency;this.locale=p.locale;this.uiConfig=p.uiConfig;this.environment=p.environment;this.whPassThroughArgs=p.whPassThroughArgs;this.cardWalletPaymentMethods=p.cardWalletPaymentMethods;this.emailInputOptions=p.emailInputOptions;this.onEvent=p.onEvent;this.experimental=p.experimental;this.height=0;this.removeEventListener=()=>{};this.removeUIEventListener=()=>{}}connectedCallback(){super.connectedCallback();let i=W(this.onEvent),{listenToEvents:d}=(0,g.crossmintPaymentService_OLD)(I(this)),{listenToEvents:l}=(0,g.crossmintUiService_OLD)({environment:this.environment});this.removeEventListener=d(h=>i==null?void 0:i(h.data)),this.removeUIEventListener=l(h=>{let{type:m,payload:k}=h.data;switch(m){case"ui:height.changed":this.height=k.height,this.requestUpdate();break;default:return}})}disconnectedCallback(){super.disconnectedCallback(),this.removeEventListener(),this.removeUIEventListener()}updated(i){super.updated(i);let{emitQueryParams:d}=(0,g.crossmintPaymentService_OLD)(I(this));(i.has("recipient")||i.has("mintConfig")||i.has("locale")||i.has("currency")||i.has("whPassThroughArgs"))&&d({recipient:this.recipient,mintConfig:this.mintConfig,locale:this.locale,currency:this.currency,whPassThroughArgs:this.whPassThroughArgs})}render(){let{getIframeUrl:i}=(0,g.crossmintPaymentService_OLD)(I(this));return y.html`
            <iframe
                src=${i()}
                allow="payment *"
                id="crossmint-embedded-checkout.iframe"
                style="border: none !important;
                padding: 0px !important;
                width: 100% !important;
                min-width: 100% !important;
                overflow: hidden !important;
                display: block !important;
                user-select: none !important;
                transform: translate(0px) !important;
                opacity: 1;
                transition: ease 0s, opacity 0.4s ease 0.1s;
                height: ${this.height}px;"
            ></iframe>
        `}};e([(0,a.property)({type:String})],c.prototype,"clientId",2),e([(0,a.property)({type:String})],c.prototype,"collectionId",2),e([(0,a.property)({type:String})],c.prototype,"projectId",2),e([(0,a.property)({type:Object})],c.prototype,"mintConfig",2),e([(0,a.property)({type:Object})],c.prototype,"recipient",2),e([(0,a.property)({type:String})],c.prototype,"paymentMethod",2),e([(0,a.property)({type:String})],c.prototype,"currency",2),e([(0,a.property)({type:String})],c.prototype,"locale",2),e([(0,a.property)({type:Object})],c.prototype,"uiConfig",2),e([(0,a.property)({type:String})],c.prototype,"environment",2),e([(0,a.property)({type:Object})],c.prototype,"whPassThroughArgs",2),e([(0,a.property)({type:Array||String})],c.prototype,"cardWalletPaymentMethods",2),e([(0,a.property)({type:Object})],c.prototype,"emailInputOptions",2),e([(0,a.property)({type:Function||String})],c.prototype,"onEvent",2),e([(0,a.property)({type:Object})],c.prototype,"experimental",2),c=e([(0,T.customElement)("crossmint-payment-element")],c);function W(t){if(t)return typeof t=="string"?new Function(t)():t}function I(t){let n;if(t.clientId?n={clientId:t.clientId}:t.collectionId&&(n={collectionId:t.collectionId}),!n)throw new Error("clientId or collectionId must be provided");return C({projectId:t.projectId,environment:t.environment,uiConfig:t.uiConfig,recipient:t.recipient,mintConfig:t.mintConfig,whPassThroughArgs:t.whPassThroughArgs,cardWalletPaymentMethods:t.cardWalletPaymentMethods,emailInputOptions:t.emailInputOptions,currency:t.currency,locale:t.locale,paymentMethod:t.paymentMethod,experimental:t.experimental,onEvent:t.onEvent},n)}var b=require("lit"),U=require("lit/decorators/custom-element.js"),r=require("lit/decorators/property.js"),R=require("lit/directives/class-map.js"),u=require("@crossmint/client-sdk-base");var M="1.1.54";var L=M;var j=require("lit"),E=j.css`
    button {
        display: flex;
        flex-direction: row;
        align-items: center;
        padding: 0.875rem 0.875rem;
        font-weight: 900;
        transition: opacity ease-in-out 0.25s;
        border-radius: 0.5rem;
        font-family: Inter, -apple-system, BlinkMacSystemFont, Segoe UI, Roboto, Oxygen, Ubuntu, Cantarell, Open Sans,
            Helvetica Neue, sans-serif;
        outline: none;
        border: none;
        box-shadow: 0px 8px 15px rgba(0, 0, 0, 0.1);
        justify-content: center;
        background: #1e1e1e;
        color: white;
    }
    button.light {
        background: white;
    }

    button:hover:enabled {
        opacity: 0.6;
        cursor: pointer;
    }

    img {
        width: 21px;
        height: 21px;
        margin-right: 0.875rem;
    }

    p {
        color: white;
        margin: 0;
    }

    button.light p {
        color: black;
    }
`;var s={className:"",theme:"dark",disabled:!1,tabIndex:0,mintTo:"",emailTo:"",listingId:"",clientId:"",collectionId:"",auctionId:"",environment:"",showOverlay:!0,onClick:void 0,whPassThroughArgs:void 0,paymentMethod:void 0,preferredSigninMethod:void 0,dismissOverlayOnClick:!1,prepay:!1,locale:"en-US",currency:"usd",successCallbackURL:"",failureCallbackURL:"",loginEmail:"",getButtonText:void 0,checkoutProps:{experimental:!1,display:"same-tab",paymentMethods:["fiat","ETH","SOL"],delivery:"all"}},o=class extends b.LitElement{constructor(){super(...arguments);this.theme=s.theme;this.disabled=s.disabled;this.mintTo=s.mintTo;this.emailTo=s.emailTo;this.listingId=s.listingId;this.clientId="";this.collectionId="";this.projectId=s.projectId;this.auctionId=s.auctionId;this.environment=s.environment;this.showOverlay=s.showOverlay;this.mintConfig=s.mintConfig;this.onClick=s.onClick;this.whPassThroughArgs=s.whPassThroughArgs;this.paymentMethod=s.paymentMethod;this.preferredSigninMethod=s.preferredSigninMethod;this.dismissOverlayOnClick=s.dismissOverlayOnClick;this.prepay=s.prepay;this.locale=s.locale;this.currency=s.currency;this.successCallbackURL=s.successCallbackURL;this.failureCallbackURL=s.failureCallbackURL;this.loginEmail=s.loginEmail;this.getButtonText=s.getButtonText;this.checkoutProps=s.checkoutProps;this.connecting=!1;this.setConnecting=i=>{this.connecting=i};this.classes={light:!1};this.modalService=null}connectedCallback(){super.connectedCallback()}render(){let{handleClick:i,getButtonText:d}=(0,u.crossmintPayButtonService)({onClick:this.onClick,connecting:this.connecting,paymentMethod:this.paymentMethod,locale:this.locale||"en-US",checkoutProps:this.checkoutProps}),l=this.getButtonText!=null?this.getButtonText(this.connecting,this.paymentMethod||"fiat"):d(this.connecting),{connect:h}=(0,u.crossmintModalService)({environment:this.environment,clientId:this.clientId||this.collectionId,projectId:this.projectId,showOverlay:this.showOverlay||!0,dismissOverlayOnClick:this.dismissOverlayOnClick,setConnecting:this.setConnecting,libVersion:L,clientName:u.clientNames.vanillaUi,locale:this.locale||"en-US",currency:this.currency||"usd",successCallbackURL:this.successCallbackURL,failureCallbackURL:this.failureCallbackURL,loginEmail:this.loginEmail}),m=k=>i(k,()=>{h(this.mintConfig,this.mintTo,this.emailTo,this.listingId,this.whPassThroughArgs,this.paymentMethod,this.preferredSigninMethod,this.prepay,this.checkoutProps)});return this.classes.light=this.theme==="light",b.html`
            <button
                class=${(0,R.classMap)(this.classes)}
                .disabled=${this.disabled}
                @click=${m}
                tabindex=${this.tabIndex}
                part="button"
            >
                <img src="https://www.crossmint.io/assets/crossmint/logo.svg" alt="Crossmint logo" />
                <span part="contentParagraph">${l}</span>
            </button>
        `}};o.styles=E,e([(0,r.property)({type:String})],o.prototype,"theme",2),e([(0,r.property)({type:Boolean})],o.prototype,"disabled",2),e([(0,r.property)({type:String})],o.prototype,"mintTo",2),e([(0,r.property)({type:String})],o.prototype,"emailTo",2),e([(0,r.property)({type:String})],o.prototype,"listingId",2),e([(0,r.property)({type:String})],o.prototype,"clientId",2),e([(0,r.property)({type:String})],o.prototype,"collectionId",2),e([(0,r.property)({type:String})],o.prototype,"projectId",2),e([(0,r.property)({type:String})],o.prototype,"auctionId",2),e([(0,r.property)({type:String})],o.prototype,"environment",2),e([(0,r.property)({type:Boolean})],o.prototype,"showOverlay",2),e([(0,r.property)({type:Object})],o.prototype,"mintConfig",2),e([(0,r.property)({type:Function})],o.prototype,"onClick",2),e([(0,r.property)({type:Object})],o.prototype,"whPassThroughArgs",2),e([(0,r.property)({type:String})],o.prototype,"paymentMethod",2),e([(0,r.property)({type:String})],o.prototype,"preferredSigninMethod",2),e([(0,r.property)({type:Boolean})],o.prototype,"dismissOverlayOnClick",2),e([(0,r.property)({type:Boolean})],o.prototype,"prepay",2),e([(0,r.property)({type:String})],o.prototype,"locale",2),e([(0,r.property)({type:String})],o.prototype,"currency",2),e([(0,r.property)({type:String})],o.prototype,"successCallbackURL",2),e([(0,r.property)({type:String})],o.prototype,"failureCallbackURL",2),e([(0,r.property)({type:String})],o.prototype,"loginEmail",2),e([(0,r.property)({type:Function})],o.prototype,"getButtonText",2),e([(0,r.property)({type:Object})],o.prototype,"checkoutProps",2),o=e([(0,U.customElement)("crossmint-pay-button")],o);var v=require("@crossmint/client-sdk-base");0&&(module.exports={CrossmintEvents,CrossmintPayButton,CrossmintPaymentElement,useCrossmintEvents});
//# sourceMappingURL=index.cjs.map