var v=Object.defineProperty;var w=Object.getOwnPropertyDescriptor;var y=Object.getOwnPropertySymbols;var O=Object.prototype.hasOwnProperty,C=Object.prototype.propertyIsEnumerable;var b=(t,s,i)=>s in t?v(t,s,{enumerable:!0,configurable:!0,writable:!0,value:i}):t[s]=i,k=(t,s)=>{for(var i in s||(s={}))O.call(s,i)&&b(t,i,s[i]);if(y)for(var i of y(s))C.call(s,i)&&b(t,i,s[i]);return t};var e=(t,s,i,p)=>{for(var d=p>1?void 0:p?w(s,i):s,h=t.length-1,m;h>=0;h--)(m=t[h])&&(d=(p?m(s,i,d):m(d))||d);return p&&d&&v(s,i,d),d};import{LitElement as T,html as M}from"lit";import{property as l}from"lit/decorators.js";import{customElement as L}from"lit/decorators/custom-element.js";import{crossmintPaymentService_OLD as u,crossmintUiService_OLD as j}from"@crossmint/client-sdk-base";var a={collectionId:"",projectId:"",mintConfig:{},recipient:{email:"",wallet:""},paymentMethod:"fiat",currency:"usd",locale:"en-US",uiConfig:{},environment:"production",whPassThroughArgs:void 0,onEvent:void 0,experimental:void 0},c=class extends T{constructor(){super(...arguments);this.clientId="";this.collectionId="";this.projectId=a.projectId;this.mintConfig=a.mintConfig;this.recipient=a.recipient;this.paymentMethod=a.paymentMethod;this.currency=a.currency;this.locale=a.locale;this.uiConfig=a.uiConfig;this.environment=a.environment;this.whPassThroughArgs=a.whPassThroughArgs;this.cardWalletPaymentMethods=a.cardWalletPaymentMethods;this.emailInputOptions=a.emailInputOptions;this.onEvent=a.onEvent;this.experimental=a.experimental;this.height=0;this.removeEventListener=()=>{};this.removeUIEventListener=()=>{}}connectedCallback(){super.connectedCallback();let i=E(this.onEvent),{listenToEvents:p}=u(f(this)),{listenToEvents:d}=j({environment:this.environment});this.removeEventListener=p(h=>i==null?void 0:i(h.data)),this.removeUIEventListener=d(h=>{let{type:m,payload:g}=h.data;switch(m){case"ui:height.changed":this.height=g.height,this.requestUpdate();break;default:return}})}disconnectedCallback(){super.disconnectedCallback(),this.removeEventListener(),this.removeUIEventListener()}updated(i){super.updated(i);let{emitQueryParams:p}=u(f(this));(i.has("recipient")||i.has("mintConfig")||i.has("locale")||i.has("currency")||i.has("whPassThroughArgs"))&&p({recipient:this.recipient,mintConfig:this.mintConfig,locale:this.locale,currency:this.currency,whPassThroughArgs:this.whPassThroughArgs})}render(){let{getIframeUrl:i}=u(f(this));return M`
            <iframe
                src=${i()}
                allow="payment *"
                id="crossmint-embedded-checkout.iframe"
                style="border: none !important;
                padding: 0px !important;
                width: 100% !important;
                min-width: 100% !important;
                overflow: hidden !important;
                display: block !important;
                user-select: none !important;
                transform: translate(0px) !important;
                opacity: 1;
                transition: ease 0s, opacity 0.4s ease 0.1s;
                height: ${this.height}px;"
            ></iframe>
        `}};e([l({type:String})],c.prototype,"clientId",2),e([l({type:String})],c.prototype,"collectionId",2),e([l({type:String})],c.prototype,"projectId",2),e([l({type:Object})],c.prototype,"mintConfig",2),e([l({type:Object})],c.prototype,"recipient",2),e([l({type:String})],c.prototype,"paymentMethod",2),e([l({type:String})],c.prototype,"currency",2),e([l({type:String})],c.prototype,"locale",2),e([l({type:Object})],c.prototype,"uiConfig",2),e([l({type:String})],c.prototype,"environment",2),e([l({type:Object})],c.prototype,"whPassThroughArgs",2),e([l({type:Array||String})],c.prototype,"cardWalletPaymentMethods",2),e([l({type:Object})],c.prototype,"emailInputOptions",2),e([l({type:Function||String})],c.prototype,"onEvent",2),e([l({type:Object})],c.prototype,"experimental",2),c=e([L("crossmint-payment-element")],c);function E(t){if(t)return typeof t=="string"?new Function(t)():t}function f(t){let s;if(t.clientId?s={clientId:t.clientId}:t.collectionId&&(s={collectionId:t.collectionId}),!s)throw new Error("clientId or collectionId must be provided");return k({projectId:t.projectId,environment:t.environment,uiConfig:t.uiConfig,recipient:t.recipient,mintConfig:t.mintConfig,whPassThroughArgs:t.whPassThroughArgs,cardWalletPaymentMethods:t.cardWalletPaymentMethods,emailInputOptions:t.emailInputOptions,currency:t.currency,locale:t.locale,paymentMethod:t.paymentMethod,experimental:t.experimental,onEvent:t.onEvent},s)}import{LitElement as A,html as F}from"lit";import{customElement as D}from"lit/decorators/custom-element.js";import{property as o}from"lit/decorators/property.js";import{classMap as N}from"lit/directives/class-map.js";import{clientNames as $,crossmintModalService as W,crossmintPayButtonService as q}from"@crossmint/client-sdk-base";var I="1.1.54";var S=I;import{css as R}from"lit";var x=R`
    button {
        display: flex;
        flex-direction: row;
        align-items: center;
        padding: 0.875rem 0.875rem;
        font-weight: 900;
        transition: opacity ease-in-out 0.25s;
        border-radius: 0.5rem;
        font-family: Inter, -apple-system, BlinkMacSystemFont, Segoe UI, Roboto, Oxygen, Ubuntu, Cantarell, Open Sans,
            Helvetica Neue, sans-serif;
        outline: none;
        border: none;
        box-shadow: 0px 8px 15px rgba(0, 0, 0, 0.1);
        justify-content: center;
        background: #1e1e1e;
        color: white;
    }
    button.light {
        background: white;
    }

    button:hover:enabled {
        opacity: 0.6;
        cursor: pointer;
    }

    img {
        width: 21px;
        height: 21px;
        margin-right: 0.875rem;
    }

    p {
        color: white;
        margin: 0;
    }

    button.light p {
        color: black;
    }
`;var r={className:"",theme:"dark",disabled:!1,tabIndex:0,mintTo:"",emailTo:"",listingId:"",clientId:"",collectionId:"",auctionId:"",environment:"",showOverlay:!0,onClick:void 0,whPassThroughArgs:void 0,paymentMethod:void 0,preferredSigninMethod:void 0,dismissOverlayOnClick:!1,prepay:!1,locale:"en-US",currency:"usd",successCallbackURL:"",failureCallbackURL:"",loginEmail:"",getButtonText:void 0,checkoutProps:{experimental:!1,display:"same-tab",paymentMethods:["fiat","ETH","SOL"],delivery:"all"}},n=class extends A{constructor(){super(...arguments);this.theme=r.theme;this.disabled=r.disabled;this.mintTo=r.mintTo;this.emailTo=r.emailTo;this.listingId=r.listingId;this.clientId="";this.collectionId="";this.projectId=r.projectId;this.auctionId=r.auctionId;this.environment=r.environment;this.showOverlay=r.showOverlay;this.mintConfig=r.mintConfig;this.onClick=r.onClick;this.whPassThroughArgs=r.whPassThroughArgs;this.paymentMethod=r.paymentMethod;this.preferredSigninMethod=r.preferredSigninMethod;this.dismissOverlayOnClick=r.dismissOverlayOnClick;this.prepay=r.prepay;this.locale=r.locale;this.currency=r.currency;this.successCallbackURL=r.successCallbackURL;this.failureCallbackURL=r.failureCallbackURL;this.loginEmail=r.loginEmail;this.getButtonText=r.getButtonText;this.checkoutProps=r.checkoutProps;this.connecting=!1;this.setConnecting=i=>{this.connecting=i};this.classes={light:!1};this.modalService=null}connectedCallback(){super.connectedCallback()}render(){let{handleClick:i,getButtonText:p}=q({onClick:this.onClick,connecting:this.connecting,paymentMethod:this.paymentMethod,locale:this.locale||"en-US",checkoutProps:this.checkoutProps}),d=this.getButtonText!=null?this.getButtonText(this.connecting,this.paymentMethod||"fiat"):p(this.connecting),{connect:h}=W({environment:this.environment,clientId:this.clientId||this.collectionId,projectId:this.projectId,showOverlay:this.showOverlay||!0,dismissOverlayOnClick:this.dismissOverlayOnClick,setConnecting:this.setConnecting,libVersion:S,clientName:$.vanillaUi,locale:this.locale||"en-US",currency:this.currency||"usd",successCallbackURL:this.successCallbackURL,failureCallbackURL:this.failureCallbackURL,loginEmail:this.loginEmail}),m=g=>i(g,()=>{h(this.mintConfig,this.mintTo,this.emailTo,this.listingId,this.whPassThroughArgs,this.paymentMethod,this.preferredSigninMethod,this.prepay,this.checkoutProps)});return this.classes.light=this.theme==="light",F`
            <button
                class=${N(this.classes)}
                .disabled=${this.disabled}
                @click=${m}
                tabindex=${this.tabIndex}
                part="button"
            >
                <img src="https://www.crossmint.io/assets/crossmint/logo.svg" alt="Crossmint logo" />
                <span part="contentParagraph">${d}</span>
            </button>
        `}};n.styles=x,e([o({type:String})],n.prototype,"theme",2),e([o({type:Boolean})],n.prototype,"disabled",2),e([o({type:String})],n.prototype,"mintTo",2),e([o({type:String})],n.prototype,"emailTo",2),e([o({type:String})],n.prototype,"listingId",2),e([o({type:String})],n.prototype,"clientId",2),e([o({type:String})],n.prototype,"collectionId",2),e([o({type:String})],n.prototype,"projectId",2),e([o({type:String})],n.prototype,"auctionId",2),e([o({type:String})],n.prototype,"environment",2),e([o({type:Boolean})],n.prototype,"showOverlay",2),e([o({type:Object})],n.prototype,"mintConfig",2),e([o({type:Function})],n.prototype,"onClick",2),e([o({type:Object})],n.prototype,"whPassThroughArgs",2),e([o({type:String})],n.prototype,"paymentMethod",2),e([o({type:String})],n.prototype,"preferredSigninMethod",2),e([o({type:Boolean})],n.prototype,"dismissOverlayOnClick",2),e([o({type:Boolean})],n.prototype,"prepay",2),e([o({type:String})],n.prototype,"locale",2),e([o({type:String})],n.prototype,"currency",2),e([o({type:String})],n.prototype,"successCallbackURL",2),e([o({type:String})],n.prototype,"failureCallbackURL",2),e([o({type:String})],n.prototype,"loginEmail",2),e([o({type:Function})],n.prototype,"getButtonText",2),e([o({type:Object})],n.prototype,"checkoutProps",2),n=e([D("crossmint-pay-button")],n);import{CrossmintEvents as pe,useCrossmintEvents as he}from"@crossmint/client-sdk-base";export{pe as CrossmintEvents,n as CrossmintPayButton,c as CrossmintPaymentElement,he as useCrossmintEvents};
//# sourceMappingURL=index.js.map